//uart.c
//ʼUARTӿ
//жϴUARTշݽ

#include "config.h"             //ͷļѰai8051u.hԼͷļ

#define NONE_PARITY     0       //У
#define ODD_PARITY      1       //У
#define EVEN_PARITY     2       //żУ

#define UART1_PARITY    NONE_PARITY   //崮1Уλ
#define UART2_PARITY    EVEN_PARITY   //崮2Уλ


u8  RX1_Cnt;            //ռ
bit B_TX1_Busy;         //æ־
bit B_RX1_TimeOut;      //ճʱ/б־

u8  RX2_Cnt;            //ռ
bit B_TX2_Busy;         //æ־
bit B_RX2_TimeOut;      //ճʱ/б־

u8  RX1_Buffer[256];    //ջ
u8  RX2_Buffer[256];    //ջ

void Uart1_Isr(void) interrupt 4
{
    if (TI)             //⴮1ж
    {
        TI = 0;         //1жλ
        B_TX1_Busy = 0; //æ־
    }
    if (RI)             //⴮1ж
    {
        RI = 0;         //1жλ
        RX1_Buffer[RX1_Cnt++] = SBUF;   //յݴ뻺
    }
    
    if(UR1TOSR & 0x01)  //Ƿʱжϣʱж˵һѾɣ
    {
        B_RX1_TimeOut = 1;  //óʱжû־
        UR1TOSR = 0x80; // RTOCF ʱ־λ TOIF
    }
}

void Uart1_Init(void)   //115200bps@40.000MHz
{
#if (UART1_PARITY == NONE_PARITY)
    SCON = 0x50;        //8λ,ɱ䲨
#else
    SCON = 0xd0;        //9λ,ɱ䲨
#endif
    AUXR |= 0x40;       //ʱʱ1Tģʽ
    AUXR &= 0xFE;       //1ѡʱ1Ϊʷ
    TMOD &= 0x0F;       //öʱģʽ
    TL1 = 0xA9;         //öʱʼֵ
    TH1 = 0xFF;         //öʱʼֵ
    ET1 = 0;            //ֹʱж
    TR1 = 1;            //ʱ1ʼʱ
    ES = 1;             //ʹܴ1ж

    UR1TOCR = 0xc0;     //ʹܳʱգʹܳʱжϣʱʱѡ 1:ϵͳʱ  0:λ()
    UR1TOTL = 0x10;     //óʱʱ䣺16λʱ
    UR1TOTH = 0x00;
    UR1TOTE = 0x00;     //Ҫд UR1TOTE µTimeOutֵŻЧ
    
#if (UART1_PARITY == EVEN_PARITY)
    USARTCR2 = 0x04;    //ʹӲżУ
#elif (UART1_PARITY == ODD_PARITY)
    USARTCR2 = 0x06;    //ʹӲУ
#else
    USARTCR2 = 0x00;    //ֹӲżУ
#endif
}

void Uart1_Send(u8 dat) //ͨ1
{
    SBUF = dat;         //дҪ͵
    B_TX1_Busy = 1;     //÷æ־
    while(B_TX1_Busy);  //жǷ
}

char putchar(char c)    // printf ӳ䵽 UART1 ӿ
{
    Uart1_Send(c);      //ô1ͺҪӳ䵽2Ļ޸Ϊ2ͺ
    return c;
}

void Uart2_Isr(void) interrupt 8
{
    if (S2CON & 0x02)   //⴮2ж
    {
        S2CON &= ~0x02; //2жλ
        B_TX2_Busy = 0; //æ־
    }
    if (S2CON & 0x01)   //⴮2ж
    {
        S2CON &= ~0x01; //2жλ
        RX2_Buffer[RX2_Cnt++] = S2BUF;  //յݴ뻺
    }
    
    if(UR2TOSR & 0x01)  //Ƿʱжϣʱж˵һѾɣ
    {
        B_RX2_TimeOut = 1;  //óʱжû־
        UR2TOSR = 0x80; // RTOCF ʱ־λ TOIF
    }
}

void Uart2_Init(void)   //115200bps@40.000MHz
{
#if (UART2_PARITY == NONE_PARITY)
    S2CON = 0x50;       //8λ,ɱ䲨
#else
    S2CON = 0xd0;       //9λ,ɱ䲨
#endif
    AUXR |= 0x04;       //ʱʱ1Tģʽ
    T2L = 0xA9;         //öʱʼֵ
    T2H = 0xFF;         //öʱʼֵ
    AUXR |= 0x10;       //ʱ2ʼʱ
    IE2 |= 0x01;        //ʹܴ2ж

    UR2TOCR = 0xc0;     //ʹܳʱգʹܳʱжϣʱʱѡ 1:ϵͳʱ  0:λ()
    UR2TOTL = 0x10;     //óʱʱ䣺16λʱ
    UR2TOTH = 0x00;
    UR2TOTE = 0x00;     //Ҫд UR2TOTE µTimeOutֵŻЧ

#if (UART2_PARITY == EVEN_PARITY)
    USART2CR2 = 0x04;   //ʹӲżУ
#elif (UART2_PARITY == ODD_PARITY)
    USART2CR2 = 0x06;   //ʹӲУ
#else
    USART2CR2 = 0x00;   //ֹӲżУ
#endif
}

void Uart2_Send(u8 dat) //ͨ2
{
    S2BUF = dat;        //дҪ͵
    B_TX2_Busy = 1;     //÷æ־
    while(B_TX2_Busy);  //жǷ
}

void PrintString2(u8 *puts)
{
    for (; *puts != 0; puts++)  //ֹͣ0
    {
        Uart2_Send(*puts);
    }
}
